/*
 * RCS info: $Source:
 *           $Revision: $
 *           $Date:$
 *           $Author:$
 *           $Log:$
 * Copyright (c) 2012 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 쐬F
 * 쐬ҁF
 * t@CFextract_fpfdat.h
 * Tv  F̓f[^k `
 *==========================================================================*/

#ifndef _DEF_LIB_EXTRACT_FPFDAT_
#define _DEF_LIB_EXTRACT_FPFDAT_


/*************************************************************************
 * CONSTANT VALUE
 *************************************************************************/

enum _fpfdat_type{
    _FPFDAT_TYPE_VAR,
    _FPFDAT_TYPE_CONST,
    _FPFDAT_TYPE_FUNC,
    _FPFDAT_TYPE_LOGCND
};


enum _fpfdat_valtype{
    _FPFDAT_VALTYPE_NON,
    _FPFDAT_VALTYPE_VOID,
    _FPFDAT_VALTYPE_BOOL,
    _FPFDAT_VALTYPE_CHAR,
    _FPFDAT_VALTYPE_SHORT,
    _FPFDAT_VALTYPE_INT,
    _FPFDAT_VALTYPE_LONG,
    _FPFDAT_VALTYPE_LONGLONG,
    _FPFDAT_VALTYPE_FLOAT,
    _FPFDAT_VALTYPE_DOUBLE,
    _FPFDAT_VALTYPE_LONGDOUBLE,
    _FPFDAT_VALTYPE_STRUCT,
};

enum _fpfdat_signed{
    _FPFDAT_SIGNED_NON,
    _FPFDAT_SIGNED,
    _FPFDAT_UNSIGNED,
};

enum _fpfdat_file_type
{
    _FPFDAT_BINARY,
    _FPFDAT_ASCII,
};

enum _fpfdat_ascii_type
{
    _FPFDAT_DEC,
    _FPFDAT_HEX,
};



#if(0) // dbg
enum _fpferep_calc_kind {
    _FPFEREP_Asgn= 1,       // 'A=B'
    _FPFEREP_Plus,          // '+A'
    _FPFEREP_Minus,         // '-A'
    _FPFEREP_Not,           // '!A'
    _FPFEREP_Mul,           // 'A * B'
    _FPFEREP_Div,           // 'A / B'
    _FPFEREP_Mod,           // 'A % B'
    _FPFEREP_Add,           // 'A + B'
    _FPFEREP_Sub,           // 'A - B'
    _FPFEREP_RightShift,    // 'A >> B'
    _FPFEREP_LeftShift,     // 'A << B'
    _FPFEREP_Les,           // 'A < B'
    _FPFEREP_LesEq,         // 'A <= B'
    _FPFEREP_Gre,           // 'A > B'
    _FPFEREP_GreEq,         // 'A >= '
    _FPFEREP_Eq,            // 'A == B'
    _FPFEREP_NotEq,         // 'A != B'
    _FPFEREP_LogAnd,        // 'A && B'
    _FPFEREP_LogOr,         // 'A || B'
    _FPFEREP_And,           // 'A & B'
    _FPFEREP_Or,            // 'A | B'
    _FPFEREP_Xor,           // 'A ^ B'
    _FPFEREP_LogCond,       // 'C?A:B '
} ;
#endif

//
// O[o֐
//

extern int _fpfdat_start( int module_no );
extern int _fpfdat_end( int module_no );

extern int _fpfdat_inp_char( int var_no, char *ptr, int size );
extern int _fpfdat_inp_uchar( int var_no, unsigned char *ptr, int size );

extern int _fpfdat_inp_short( int var_no, short *ptr, int size );
extern int _fpfdat_inp_ushort( int var_no, unsigned short *ptr, int size );

extern int _fpfdat_inp_int( int var_no, int *ptr, int size );
extern int _fpfdat_inp_uint( int var_no, unsigned int *ptr, int size );

extern int _fpfdat_inp_long( int var_no, long *ptr, int size );
extern int _fpfdat_inkp_ulong( int var_no, unsigned long *ptr, int size );

extern int _fpfdat_inp_long2( int var_no, long long *ptr, int size );
extern int _fpfdat_inp_ulong2( int var_no, unsigned long long *ptr, int size);

extern int _fpfdat_inp_float( int var_no, float *ptr, int size );
extern int _fpfdat_inp_double( int var_no, double *ptr, int size );

extern int _fpfdat_outp_char( int var_no, char *ptr, int size );
extern int _fpfdat_outp_uchar( int var_no, unsigned char *ptr, int size );

extern int _fpfdat_outp_short( int var_no, short *ptr, int size );
extern int _fpfdat_outp_ushort( int var_no, unsigned short *ptr, int size );

extern int _fpfdat_outp_int( int var_no, int *ptr, int size );
extern int _fpfdat_outp_uint( int var_no, unsigned int *ptr, int size );

extern int _fpfdat_outp_long( int var_no, long *ptr, int size );
extern int _fpfdat_outp_ulong( int var_no, unsigned long *ptr, int size );

extern int _fpfdat_outp_long2( int var_no, long long *ptr, int size );
extern int _fpfdat_outp_ulong2(int var_no, unsigned long long *ptr, int size);

extern int _fpfdat_outp_float( int var_no, float *ptr, int size );
extern int _fpfdat_outp_double( int var_no, double *ptr, int size );

extern int _fpfdat_upd_double( int var_no, double d_data );

#endif // !_DEF_LIB_EXTRACT_FPFDAT_

