/*
 * RCS info: $Source: /export/work/usr/CVS_DB/FP-Fixer/src/lib/fpfsim/fpfMath_sim.h,v $
 *           $Revision: 1.3 $
 *           $Date: 2010/02/25 10:03:24 $
 *           $Author: haru $
 *           $Log: fpfMath_sim.h,v $
 *           Revision 1.3  2010/02/25 10:03:24  haru
 *           *** empty log message ***
 *
 *           Revision 1.2  2009/03/03 10:00:40  haru
 *
 *           Chg. mul
 *           Add. math floor, ceil
 *           Chg. (1 << f_width) -> (1U << f_width)
 *
 *           Revision 1.1  2009/02/23 05:13:50  haru
 *
 *           new version
 *
 *           Revision 1.2  2008/11/28 07:25:48  haru
 *           first cvs modules.
 *
 * Copyright (c) 2009 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 
 * ԡ
 * ե̾fpfMath_sim.h
 *   mathϴؿåѡإå
 *==========================================================================*/

#ifndef _FPFSIM_MATH_HPP
#define _FPFSIM_MATH_HPP

extern double fpfMath_fabs( fpf_Fixed x, int r_fsize );
extern double fpfMath_pow( fpf_Fixed x, fpf_Fixed y, int r_fsize );
extern double fpfMath_ldexp( fpf_Fixed x, fpf_Int i_exp, int r_fsize );
extern double fpfMath_modf( fpf_Fixed x, fpf_Fixed *intptr, int r_fsize );
extern double fpfMath_frexp( fpf_Fixed x, fpf_Int *expptr, int r_fsize );
extern double fpfMath_fmod( fpf_Fixed x, fpf_Fixed y, int r_fsize );
extern double fpfMath_sqrt( fpf_Fixed x, int r_fsize );
extern double fpfMath_exp( fpf_Fixed x, int r_fsize );
extern double fpfMath_log10( fpf_Fixed x, int r_fsize );
extern double fpfMath_log( fpf_Fixed x, int r_fsize );
extern double fpfMath_sin( fpf_Fixed x, int r_fsize );
extern double fpfMath_cos( fpf_Fixed x, int r_fsize );
extern double fpfMath_tan( fpf_Fixed x, int r_isize, int r_fsize );
extern double fpfMath_asin( fpf_Fixed x, int r_fsize );
extern double fpfMath_acos( fpf_Fixed x, int r_fsize );
extern double fpfMath_atan( fpf_Fixed x, int r_fsize );
extern double fpfMath_atan2( fpf_Fixed y, fpf_Fixed x, int r_fsize );
extern double fpfMath_sinh( fpf_Fixed x, int r_fsize );
extern double fpfMath_cosh( fpf_Fixed x, int r_fsize );
extern double fpfMath_tanh( fpf_Fixed x, int r_fsize );
extern double fpfMath_floor( fpf_Fixed x, int r_fsize );
extern double fpfMath_ceil( fpf_Fixed x, int r_fsize );

#endif


